#include "Element.h"

using namespace std;
using namespace graphic;

//  constructor
Element::Element(int r, int c, vector < StatisticalValue * > stats) : IsoObject(r, c)
{   
    // number of passed stats
    int num_stats = stats.size();
    
    // store energy stat
    for(int i = 0; i < num_stats ; i++)
        a_stats.push_back(stats[i]);
}

// Full constructor
Element::Element(int r, int c, vector < Image * > views, vector < StatisticalValue * > stats) : IsoObject(r, c)
{
    // store views
    for(int i = 0; i < NUM_VIEWS; i++)
        a_views.push_back(views[i]);
    
    // set default view
    a_img = a_views[SOUTH];
    
    // number of passed stats
    int num_stats = stats.size();
    
    // store energy stat
    for(int i = 0; i < num_stats ; i++)
        a_stats.push_back(stats[i]);
    
    // default orientation
    a_direction = SOUTH;
}

// Destroyer
Element::~Element()
{    
    int num_stats = a_stats.size();
    
    // delete all stats
    for(int i = 0; i < num_stats; i++)
        delete a_stats[i];
    
    a_stats.clear();
}

