#ifndef CLASS_ISO_FOW
#define CLASS_ISO_FOW

#include "graphic/Blitter.h"
#include "graphic/Image.h"
#include "IsoTilesMap.h"
#include "Layer.h"
#include "Tile.h"

#define FOW_DEFAULT_OPACITY 120

/// This layer that represents the FOG OF WAR
class IsoFow : public Layer
{
	private:
		/// black tile
		graphic::Image * a_image;
		/// width of the tile
		Uint16 a_tile_width;
		/// height of the tile
		Uint16 a_tile_height;
        /// number of rows 
        int a_num_rows;
        /// number of columns 
        int a_num_cols;
        /// side of an orthogonal tile 
        float a_square_side;
		/// pointer to the Isometric Tiles Map
		IsoTilesMap * a_tm;
  
        /// origin of the map
        Point a_origin;
   
		
	public:
		/// base constructor, use a map to choose tiles
        IsoFow(IsoTilesMap * tm, graphic::Image * image);
		/// destroyer
		~IsoFow() { };
			
		/// blit all the fog on a surface
		void BlitLayer(graphic::BaseSurface & dst_surf, SDL_Rect * limits_rect);
		/// blit the grid on a surface
		void BlitLayer(graphic::BaseSurface & dst_surf);

		/// Set opacity of the grid
		void SetOpacity(Uint8 opacity) { a_image->SetOpacity(opacity); };
};

#endif
