#ifndef CLASS_ISOMETRIC_OBJECT
#define CLASS_ISOMETRIC_OBJECT

#include "graphic/Blitter.h"
#include "graphic/Image.h"
#include "Object.h"

/// A tile of a landscape
class IsoObject: public Object 
{
	private:
		/// number of rows that made the object
		int a_num_rows;
        /// number od colons that made the object
		int a_num_cols;
		/// flag that remember if an object is opaque or transparent
		//bool a_opaque;
        
    protected:
        /// image that represent the object
        graphic::Image * a_img;
		
	public:
		/// Base IsoObject constructor, just set row and col
		IsoObject(int r = 0, int c = 0);
        /// IsoObject constructor, set row and col and the object image
        IsoObject(int r, int c, graphic::Image * img);
		/// IsoObject destroyer
		~IsoObject() {};

        /// return the number of rows of the object
		int GetNumRows() { return a_num_rows; };
        /// return the number of cols of the object
		int GetNumCols() { return a_num_cols; };
		
  /*
        /// set the opaque flag of the object
		void SetOpaque(bool op = true) { a_opaque = op; };
        /// return true if the object is opaque
		bool IsOpaque() { return a_opaque; };
  */
  
        /// return image pointer
        graphic::Image * GetImage() { return a_img;};
        
        /// return the width of the current image
        Uint16 GetW() { return a_img->GetW(); };
        /// return the height of the current image
        Uint16 GetH() { return a_img->GetH(); };

        /// true if ob1 is ahead ob2
		friend bool operator>(IsoObject & ob1, IsoObject & ob2);
        /// true if ob1 is behind ob2
		friend bool operator<(IsoObject & ob1, IsoObject & ob2);
};

#endif
