#include "Map.h"

// constructor
Map::Map(int num_rows, int num_cols)
{
	// setting numbers of rows and cols
	a_num_rows = num_rows;
	a_num_cols = num_cols;
	
	// setting number of cells
	a_num_cells = num_rows * num_cols;
		
	// no objects yet
	a_num_objects = 0;
	
	// default origin point is (0,0)
	a_origin.x = 0;
	a_origin.y = 0;

    // no image by default
    a_graphic_origin.x = 0;
    a_graphic_origin.y = 0;
	
	// in the beginning 0 width and height
	a_width = 0;
	a_height = 0;

}

// destroyer
Map::~Map()
{
	// free all created objects
	for(int i = 0; i < a_num_objects; i++)
		delete a_objects[i];
}

// Set X coordinate of the origin point, then update all objects X value
void Map::SetOriginX(Sint16 new_x)
{
	int diff = a_origin.x - new_x;
	
	a_origin.x -= diff;
    a_graphic_origin.x -= diff;
	
	// update all objects position
	for(int i = 0; i < a_num_objects; i++)
		a_objects[i]->SetXPosition(a_objects[i]->GetX() - diff);
}

// Set Y coordinate of the origin point, then update all objects Y value
void Map::SetOriginY(Sint16 new_y)
{
	int diff = a_origin.y - new_y;
	
	a_origin.y -= diff;
    a_graphic_origin.y -= diff;
	
	// update all objects position
	for(int i = 0; i < a_num_objects; i++)
		a_objects[i]->SetYPosition(a_objects[i]->GetY() - diff);
}
