#include "MovableElement.h"
     
// move the element to the [dest_x, dest_y] point 
// return true when the destination is reached
bool MovableElement::MoveTo(Sint16 dest_x, Sint16 dest_y, int mov_x, int mov_y)
{
    // current distance by the destination
    int x_diff = dest_x - a_position.x;                
    int y_diff = dest_y - a_position.y;
    
    // destination reached
    if(x_diff == 0 && y_diff == 0)
        return true;            
    
    if(x_diff < 0)
    {
        if(x_diff <= -mov_x)
            a_position.x -= mov_x;            
        else
            a_position.x += x_diff;            
    }
    else
    {
        if(x_diff >= mov_x)
            a_position.x += mov_x;             
        else
            a_position.x += x_diff;
    }
                    
    if(y_diff < 0)
    {
        if(y_diff <= -mov_y)
            a_position.y -= mov_y;             
        else
            a_position.y += y_diff;                         
    }
    else
    {
        if(y_diff >= mov_y)
            a_position.y += mov_y;            
        else
            a_position.y += y_diff;                                     
    }   
    
    return false;
}

