#ifndef CLASS_MOVABLE_ELEMENT
#define CLASS_MOVABLE_ELEMENT

#include "Element.h"

/// this class introduces methods that make an element movable
class MovableElement : public virtual Element
{
	private:
     /// this flag is set to true if the element is moving, false if not
     bool a_moving;
        
	public:
     /// Constructor
     MovableElement() { a_moving = false; };
     
     /// Destroyer
     virtual ~MovableElement() {};
                  
     /// move the element to the [dest_x, dest_y] point
     /// return true when the destination is reached
     bool MoveTo(Sint16 dest_x, Sint16 dest_y, int mov_x, int mov_y);
     
     /// return true if the element is moving
     bool IsMoving() { return a_moving; };
     /// start moving, set the flag to true
     void StartMoving() { a_moving = true; };
     /// stop moving, set the flag to false
     void StopMoving() { a_moving = false; };
};

#endif
