#include "Path.h"

// Destroyer
Path::~Path()
{
    int path_len = a_path.size();
       
    // delete all nodes 
    for(int i = 0; i < path_len; i++)
        delete a_path[i];
    
    a_path.clear();
}
             
// add a node passing row, col and cost
void Path::AddNode(int row, int col, int cost, int dir)
{
    PathNode * node = new PathNode(row, col, cost, dir);    

    a_total_cost += cost;
    
    a_path.push_back(node);

}

// return the first node and remove it from the path
PathNode * Path::PopNode()
{
    // path empty
    if(a_path.empty())
        return NULL;        
            
    PathNode * node = a_path.front();
    
    // remove cost of the node from the total cost    
    a_total_cost -=  node->GetCost();   
            
    // remove first node from the vector
    a_path.erase(a_path.begin());
    
    return node;
}

