#ifndef CLASS_PATH_NODE
#define CLASS_PATH_NODE

#include "DataTypes.h"

/// a node that make a path
class PathNode
{
	private:
     /// cell indexes of the node
     CellInd a_indexes;     
     /// direction that an element has to follow passing this node
     int a_direction;
     /// cost needed to pass through the node
     int a_cost;

	public:
     /// base constructor, inits default attributes
     PathNode(int row, int col)
     {
         a_indexes.row = row;  
         a_indexes.col = col;
         a_cost = 0;
         a_direction = 0;         
     }
     
     /// constructor, inits attributes
     PathNode(int row, int col, int cost, int direction)
     {
         a_indexes.row = row;  
         a_indexes.col = col;
         a_cost = cost;
         a_direction = direction;         
     }
     /// Destroyer
     virtual ~PathNode() { };

     /// set cost value
     void SetCost(int cost) { a_cost = cost; };
     /// set the row
     void SetRow(int row) { a_indexes.row = row; };
     /// set the col
     void SetCol(int col) { a_indexes.col = col; };
     
     /// set the direction that an element has to follow passing this node
     void SetDirection(int direction) { a_direction = direction; };
     
     /// return the direction that an element has to follow passing this node
     int GetDirection() { return a_direction; };

     /// return cost value
     int GetCost() { return a_cost; }; 
     
     /// return cell row
     int GetRow() { return a_indexes.row; };
     /// return cell col
     int GetCol() { return a_indexes.col; };

};
#endif
