#include "PathfindHeap.h"

// add a node to the heap
void PathfindHeap::AddNode(PathfindNode * node)
{
    // push the node back to the vector
    a_heap.push_back(node);
    // sort the element into the heap
    push_heap(a_heap.begin(), a_heap.end(), GreaterPathfindNode());
    
}

// return the head element and remove it from the heap
PathfindNode * PathfindHeap::GetHead()
{
    // no nodes
    if(a_heap.empty())
        return NULL;
    
    // move the current head to the back of the vector
    pop_heap(a_heap.begin(), a_heap.end(), GreaterPathfindNode());
    
    // copy the head
    PathfindNode * head = a_heap[(a_heap.size() - 1)];
    
    // remove it from the vector
    a_heap.pop_back();
       
    return head;    
}

// return the element identified by passed id
PathfindNode * PathfindHeap::SearchNode(int id)
{
    int heap_size = a_heap.size();
    
    // look for the node
    for(int i = 0; i < heap_size; i++)
        if(a_heap[i]->GetId() == id)
            return a_heap[i];
    
    // no right node found
    return NULL;
}

// destroy and removes all the elements from the heap
void PathfindHeap::Clear()
{
    int num_elem =  a_heap.size();
    
    // delete all nodes
    for(int i = 0; i < num_elem; i++)
        delete a_heap[i];
    
    a_heap.clear();
}


