#include "SceneElement.h"

using namespace std;
using namespace graphic;

// Constructor
SceneElement::SceneElement(int r, int c, vector < Image * > & views, 
                           vector < StatisticalValue * > stats) : Element(r, c, stats)
{
    // set all the views pointes to 0
    for(int i = 0; i < NUM_VIEWS; i++)
        a_views.push_back(NULL);
    
    // set north and south views
    a_views[NORTH] = views[0];
    a_views[SOUTH] = views[1];
    
    // set default view
    a_img = a_views[SOUTH];

    // set the type
    a_type = SCENE_ELEMENT;
}
     
// set the image that should be blitted
void SceneElement::SetDirection(int direction)
{
    if(direction != NORTH && direction != SOUTH)   
        return;
    
    a_direction = direction;
    a_img = a_views[direction]; 
}
