#ifndef CLASS_SELECTION_DATA
#define CLASS_SELECTION_DATA

#include "graphic/Image.h"
#include "Element.h"
#include "Layer.h"

#define BAR_BORDER_IMG 0
#define BAR_GOOD_IMG 1
#define BAR_BAD_IMG 2

#define BORDER_V_OFFSET 30

#define BAR_H_OFFSET 1
#define BAR_V_OFFSET 1

/// this layer is used to show element stats, like energy or rank
class SelectionData : public Layer
{
	private:
        /// current selected object
        Element * a_sel_elem;        
        /// images used to show data of selected element
        std::vector < graphic::Image * > a_images; 
        
	public:
        /// constructor
        SelectionData(std::vector < graphic::Image * > images);
        /// destroyer
        ~SelectionData() { };
        
        /// Store a pointer to the selected object
        void SetSelected(Element * obj) { a_sel_elem = obj; };
        /// Set the  pointer to the selected object to NULL
        void ClearSelected() { a_sel_elem = NULL; };
        
        /// return true if an object is selected
        bool IsSelected() { return (a_sel_elem != NULL); };
        
        /// Blit the effect on a surface if it fits the limits rect
        void BlitLayer(graphic::BaseSurface & dst_surf, SDL_Rect * limits_r);
        /// Blit the effect on a surface
        void BlitLayer(graphic::BaseSurface & dst_surf);
};

#endif
