#include "SelectionHighlighter.h"

using namespace graphic;
using namespace std;

// constructor
SelectionHighlighter::SelectionHighlighter(std::vector < Image * > images)
{
    int num_imgs = images.size();
    
    // store images pointers
    for(int i = 0; i < num_imgs; i++)
    {
        images[i]->SetOpacity(SELECT_OPACITY);
        a_images.push_back(images[i]);
    }
            
    // no obj selected by default
    a_sel_elem = NULL;
}

// Blit the effect on a surface if it fits the limits rect
void SelectionHighlighter::BlitLayer(BaseSurface & dst_surf, SDL_Rect * limits_r)
{
    // no elem selected
    if(a_sel_elem == NULL)
        return ;
    
    Sint16 l_limit = limits_r->x ;
    Sint16 r_limit = limits_r->x + limits_r->w;
    Sint16 u_limit = limits_r->y;
    Sint16 b_limit = limits_r->y + limits_r->h;
    
    Image * obj_img = a_sel_elem->GetImage();
    Image * corner;
        
    // temporary Point
    Point * p = new Point;
    
    // top left corner
    corner = a_images[0];    
    p->x = a_sel_elem->GetX() + obj_img->GetVisibleX() - H_SPACE;
    p->y = a_sel_elem->GetY() + obj_img->GetVisibleY() - V_SPACE;                    

    if((p->x + corner->GetW() >= l_limit) && (p->y + corner->GetH() >= u_limit))
    {
        corner->SetPosition(p->x - l_limit, p->y - u_limit);
        blitter->Blit(*(corner), dst_surf);
    }
    
    // top right corner
    corner = a_images[1];   
    p->x = a_sel_elem->GetX() + obj_img->GetVisibleW() - corner->GetW() + H_SPACE;            
        
    if((p->x <= r_limit) && (p->y + corner->GetH() >= u_limit))
    {
        corner->SetPosition(p->x - l_limit, p->y - u_limit);
        blitter->Blit(*(corner), dst_surf);
    }
       
    // bottom left corner
    corner = a_images[2];    
    p->x = a_sel_elem->GetX() + obj_img->GetVisibleX() - H_SPACE;
    p->y = a_sel_elem->GetY() + obj_img->GetVisibleH() - corner->GetH() + V_SPACE;      
        
    if((p->x + corner->GetW() >= l_limit) && (p->y <= b_limit))
    {
        corner->SetPosition(p->x - l_limit, p->y - u_limit);
        blitter->Blit(*(corner), dst_surf);
    }   
    
    // bottom right corner
    corner = a_images[3];
    p->x = a_sel_elem->GetX() + obj_img->GetVisibleW() - corner->GetW() + H_SPACE;
        
    if((p->x <= r_limit) && (p->y <= b_limit))
    {
        corner->SetPosition(p->x - l_limit, p->y - u_limit);
        blitter->Blit(*(corner), dst_surf);
    }
    
    delete p;
}

// Blit the effect on a surface
void SelectionHighlighter::BlitLayer(BaseSurface & dst_surf)
{
    if(a_sel_elem == NULL)
        return ;
}
