#ifndef CLASS_SELECTION_HIGHLIGHTER
#define CLASS_SELECTION_HIGHLIGHTER

#include <vector>

#include "graphic/Image.h"
#include "Element.h"
#include "Layer.h"

#define H_SPACE 10
#define V_SPACE 10

#define SELECT_OPACITY 128

/// layer that shows graphic selection highlighter
class SelectionHighlighter : public Layer
{
	private:
        /// current selected object
        Element * a_sel_elem;
        
        /// images that made the highlighter
        std::vector < graphic::Image * > a_images; 

	public:
        /// constructor
        SelectionHighlighter(std::vector < graphic::Image * > images);
        /// destroyer
        ~SelectionHighlighter() { };
        
        /// Store a pointer to the selected object
        void SetSelected(Element * obj) { a_sel_elem = obj; };
        /// Set the  pointer to the selected object to NULL
        void ClearSelected() { a_sel_elem = NULL; };
        
        /// return true if an object is selected
        bool IsSelected() { return (a_sel_elem != NULL); };
        
        /// Blit the effect on a surface if it fits the limits rect
        void BlitLayer(graphic::BaseSurface & dst_surf, SDL_Rect * limits_r);
        /// Blit the effect on a surface
        void BlitLayer(graphic::BaseSurface & dst_surf);
};

#endif
