#ifndef CLASS_STATISTICAL_VALUE
#define CLASS_STATISTICAL_VALUE


/// A single statistical value of an element
class StatisticalValue
{
	private:
     /// top value
     int a_max;
     /// current value
     int a_cur;
	
	public:
        /// Constuctor
        StatisticalValue(int max)
        {
            a_max = max;
            a_cur = max;   
        };
        /// Full constructor 
        StatisticalValue(int max, int cur)
        {
            a_max = max;
            a_cur = cur;   
        };
        /// Destroyer
        ~StatisticalValue() {};

        /// return the max value
        int GetMax() { return a_max; };
        /// set the max value
        void SetMax(int val) { a_max = val; };
        /// add a value to the max
        void AddMax(int val) { a_max += val; };
        /// subtract a value to the max
        void SubMax(int val) 
        { 
            if((a_max - val) > 0)
                a_max -= val;
            else
                a_max = 0;
        };
        
        /// return the current value
        int GetCur() { return a_cur; };
        /// set the current value
        void SetCur(int val) 
        { 
            if(val <= a_max && val >= 0)
                a_cur = val; 
        };
        /// add a value to the current
        void AddCur(int val) 
        { 
            if(a_cur + val <= a_max)
                a_cur += val; 
            else
                a_cur = a_max;
        };
        /// subtract a value to the current
        void SubCur(int val) 
        { 
            if((a_cur - val) > 0)
                a_cur -= val;
            else
                a_cur = 0;
        };
        
        /// restore the current value to the max value
        void RestoreCur() { a_cur = a_max; };
};

#endif
