#include "AlphaImage.h"

#include <iostream>

using namespace std;

// Base constructor, Create a new image
graphic::AlphaImage::AlphaImage(string file)
{    
    // Temporary surface
    SDL_Surface *temp;
    
    // Load image
    temp = IMG_Load(file.c_str());
	
    // ERROR
	if(temp == NULL)
	{
		cout << "[ERROR] AlphaImage: " << file << " [ERROR]" << endl;
        cout << IMG_GetError() << endl;

        // kill the program
        exit(0);
    }
 
    SDL_SetAlpha(temp , SDL_SRCALPHA | SDL_RLEACCEL , SDL_ALPHA_OPAQUE);
    a_surface = SDL_DisplayFormatAlpha(temp); 

	// Setting default position
	a_rectangle->x = 0;
    a_rectangle->y =0;
	// Setting image dimensions
	a_rectangle->w = a_surface->w;
	a_rectangle->h = a_surface->h;
 
    // Free temporary surface
    SDL_FreeSurface(temp);
    
    a_vis_rect = new SDL_Rect;
                
    int first_x = a_surface->w - 1;
    int first_y = a_surface->h - 1;    
    int last_x = 0;
    int last_y = 0;
    
    Lock();
            
    for(int x = 0; x < a_surface->w; x++)
    {
        for(int y = 0; y < a_surface->h; y++)
        {
            // opaque color
            if(GetAlpha(x, y) > MIN_TRANS)
            {
                if(x < first_x)   
                    first_x = x;
                if(x > last_x)
                    last_x = x;
                
                if(y < first_y)   
                    first_y = y;
                if(y > last_y)
                    last_y = y;                
            }            
        }
    }
    
    Unlock();
    
    a_vis_rect->x = first_x;
    a_vis_rect->y = first_y;
    a_vis_rect->w = last_x;
    a_vis_rect->h = last_y;
}

