#ifndef CLASS_ALPHA_IMAGE
#define CLASS_ALPHA_IMAGE

#include <string>
#include <iostream>
#include <SDL_image.h>
#include "Image.h"

#define MIN_TRANS 50

namespace graphic
{
/// A surface loaded from an image file
class AlphaImage : public virtual Image
{
	
	public:
		/// Base constructor, Create a new image
		AlphaImage(std::string file);
		/// Destroyer
		~AlphaImage() {};

        /// return true if the pixel at x,y is transparent, false otherwise
        bool IsTrans(Uint16 x, Uint16 y)
        {
            if(GetAlphaLocked(x, y) <= MIN_TRANS)
                return true;
            else
                return false;
        };              
};

}
#endif
