#ifndef CLASS_SDL_BLITTER
#define CLASS_SDL_BLITTER

#include "Blitter.h"

namespace graphic
{
/// BaseSurface blitting class (SDL)
class SdlBlitter : public Blitter
{
	public:
		/// constructor
		SdlBlitter() {};
		/// destroyer
		~SdlBlitter() {};
		
		// NULL -> NULL
		/// Copy an entire surface on screen (must have the same size)
		void Copy(BaseSurface & src_surface) { SDL_BlitSurface(a_sf->GetSurface(src_surface), 
			NULL, a_sf->GetSurface(*screen), NULL); } ;
		/// Copy an entire surface on another one of the same size
		void Copy(BaseSurface & src_surface, BaseSurface & dst_surface) { SDL_BlitSurface(
			a_sf->GetSurface(src_surface), NULL, a_sf->GetSurface(dst_surface), NULL); };
		
		// NULL -> Rect
		/// Blit an entire surface on screen
		void Blit(BaseSurface & src_surface);
		/// Blit an entire surface on another one
		void Blit(BaseSurface & src_surface, BaseSurface & dst_surface);
		
		// Rect -> NULL
		/// Blit part of a surface on screen
		void Blit(BaseSurface & src_surface, SDL_Rect & src_rect);
		/// Blit part of a surface on another one
		void Blit(BaseSurface & src_surface, SDL_Rect & src_rect, 
				  BaseSurface & dst_surface) ;
		
		// rect -> Rect
		/// Blit part of a surface on part of screen
		void Blit(BaseSurface & src_surface, SDL_Rect & src_rect, 
				  SDL_Rect & dst_rect);
		/// Blit part of a surface on part of another one
		void Blit(BaseSurface & src_surface, SDL_Rect & src_rect, 
				  BaseSurface & dst_surface, SDL_Rect & dst_rect);
};

}
#endif
