#include "Text.h"
#include <iostream>

using namespace std;

// Base constructor, Create a surface from a text
graphic::Text::Text(string text, SDL_Color text_color, string font_file, int size)
{
	TTF_Font *font;
	int width, height;
	
	// Loading the font
	font = TTF_OpenFont(font_file.c_str(), size);
    // ERROR
    if(font == NULL)
    {
        cout << "[ERROR] Font: " << font_file << " [ERROR]" << endl;
        cout << TTF_GetError() << endl;
        
        // kill the program
        exit(0);
    }
    
	TTF_SizeText(font, text.c_str(), &width, &height);

	// rendering the font on the surface	
    a_surface = TTF_RenderText_Blended(font, text.c_str(), text_color);        
    // ERROR
    if(a_surface == NULL)
    {
        cout << "[ERROR] Font - \"" << text << "\" [ERROR]" << endl;
        cout << TTF_GetError() << endl;
        
        // kill the program
        exit(0);
    }

	// Setting default position
	a_rectangle->x = 0;
	a_rectangle->y = 0;
	// Setting image dimensions
	a_rectangle->w = a_surface->w;
	a_rectangle->h = a_surface->h;
 
    TTF_CloseFont(font);
}

// constructor, create a surface from a number
graphic::Text::Text(int number, SDL_Color text_color, string font_file, int size)
{

    TTF_Font *font;
    int width, height;
    
    string * text = int2str(number);

    // Loading the font
    font = TTF_OpenFont(font_file.c_str(), size);
    // ERROR
    if(font == NULL)
    {
        cout << "[ERROR] Font: " << font_file << " [ERROR]" << endl;
        cout << SDL_GetError() << endl;
        cout << TTF_GetError() << endl;
        
        // kill the program
        exit(0);
    }
    
    TTF_SizeText(font, text->c_str(), &width, &height);

    // rendering the font on the surface    
    a_surface = TTF_RenderText_Blended(font, text->c_str(), text_color);
    // ERROR
    if(a_surface == NULL)
    {
        cout << "[ERROR] Font - \"" << text << "\" [ERROR]" << endl;
        cout << SDL_GetError() << endl;
        cout << TTF_GetError() << endl;
        
        // kill the program
        exit(0);
    }

    // Setting default position
    a_rectangle->x = 0;
    a_rectangle->y = 0;
    // Setting image dimensions
    a_rectangle->w = a_surface->w;
    a_rectangle->h = a_surface->h;
    
    delete text;
    TTF_CloseFont(font);
}

// convert from int to string
string * graphic::Text::int2str(int num)
{
    string * str = new string;   
        
    int cur_digit;
    char numbers[10] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
    
    bool get_digit = true;
    bool negative = false;
    
    stack < char > digits;
    
    if(num < 0)
    {
        num *= -1;
        negative = true;
    }
    
    while(get_digit)
    {
        cur_digit = num % 10;
        num /= 10;     
        
        if(num == 0)
            get_digit = false;
        
        digits.push(numbers[cur_digit]);
    }
    
    if(negative)
        (* str) += '-';
      
    while(!digits.empty())
    {
        (* str) += digits.top();
        digits.pop();
    }        
    
    return str;
}
